{% extends "base.html" %}

{% set active_page = "assets" %}

{% block title %} {{asset.name}} {% endblock %}



{% block divs %}
<nav aria-label="breadcrumb">
  <ol class="breadcrumb">
    {% for breadcrumb in breadcrumb_info["ancestors"] %}
      <li class="breadcrumb-item{% if loop.last %} active{% endif %}" {% if loop.last %}aria-current="page"{% endif %}>
        {% if breadcrumb["url"] is not none and not loop.last %}
          <a href="{{ breadcrumb['url'] }}">{{ breadcrumb['name'] }}</a>
        {% else %}
          {{ breadcrumb['name'] }}
        {% endif %}
      </li>
    {% endfor %}
  </ol>
</nav>


<div class="container-fluid">
    <div class="row">
        <div class="alert alert-info" id="tzwarn" style="display:none;"></div>
        <div class="alert alert-info" id="dstwarn" style="display:none;"></div>
    </div>
    <div class="row">
        <div class="col-sm-2 on-top-md">
            <div class="header-action-button">
                {% if user_can_create_assets %}
                <div class="">
                    <form action="/assets/new" method="get">
                        <button class="btn btn-sm btn-responsive btn-success create-button" type="submit">Create new asset</button>
                    </form>
                </div>
                {% endif %}
                {% if user_can_delete_asset %}
                <div class="">
                    <form action="/assets/delete_with_data/{{ asset.id }}/" method="get">
                        <button id="delete-asset-button" class="btn btn-sm btn-responsive btn-danger delete-button" type="submit">Delete this asset</button>
                    </form>
                    <script>
                        $("#delete-asset-button").click(function () {
                            if (confirm("Are you sure you want to delete this asset and all time series data associated with it?")) {
                                return true;
                            }
                            else {
                                return false;
                            }
                        });
                    </script>
                </div>
                {% endif %}
            </div>
            <div class="sidepanel-container">
                <div class="left-sidepanel-label">Select dates</div>
                <div class="sidepanel left-sidepanel">
                    <div id="datepicker"></div>
                </div>
            </div>
            <div class="sidepanel-container">
                <div class="left-sidepanel-label">Edit asset</div>
                <div class="sidepanel left-sidepanel">
                    <form class="form-horizontal" method="POST" action="/assets/{{ asset.id }}/">
                        {{ asset_form.csrf_token }}
                        {{ asset_form.hidden_tag() }}
                        <fieldset>
                            <div class="asset-form">

                                <h3>Edit {{ asset.name }}</h3>
                                <small>Owned by account: {{ asset.account_id | accountname }} (ID: {{ asset.account_id }})</small>

                                <div class="form-group">
                                    {{ asset_form.name.label(class="col-sm-3 control-label") }}
                                    <div class="col-sm-3">
                                        {{ asset_form.name(class_="form-control") }}
                                        {% for error in asset_form.errors.name %}
                                        <span style="color: red;">[{{error}}]</span>
                                        {% endfor %}
                                    </div>
                                </div>
                                <div class="form-group">
                                    {{ asset_form.latitude.label(class="col-sm-6 control-label") }}
                                    <div class="col-sm-6">
                                        {{ asset_form.latitude(class_="form-control") }}
                                        {% for error in asset_form.errors.latitude %}
                                        <span style="color: red;">[{{error}}]</span>
                                        {% endfor %}
                                    </div>
                                </div>
                                <div class="form-group">
                                    {{ asset_form.longitude.label(class="col-sm-6 control-label") }}
                                    <div class="col-sm-6">
                                        {{ asset_form.longitude(class_="form-control") }}
                                        {% for error in asset_form.errors.longitude %}
                                        <span style="color: red;">[{{error}}]</span>
                                        {% endfor %}
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label for="assset-type" class="col-sm-6 control-label">Asset Type</label>
                                     <div class="col-sm-6">
                                        <input class="form-control" id="asset-type-id" name="asset-type" type="text"
                                            value="{{ asset.generic_asset_type.name }}" disabled></input>
                                     </div>
                                </div>
                                <div class="form-group">
                                    <label for="asset-id" class="col-sm-6 control-label">Asset id</label>
                                    <div class="col-sm-6">
                                        <input class="form-control" id="asset-id" name="asset-id" type="text" value="{{ asset.id }}"
                                            disabled></input>
                                    </div>
                                </div>
                                <div class="form-group">
                                    {{ asset_form.attributes.label(class="col-sm-3 control-label") }}
                                    <div class="col-sm-3">
                                        {{ asset_form.attributes(class_="form-control") }}
                                        {% for error in asset_form.errors.attributes %}
                                        <span style="color: red;">[{{error}}]</span>
                                        {% endfor %}
                                    </div>
                                </div>
                                <label class="control-label">Location</label>
                                <small>(Click map to edit latitude and longitude in form)</small>
                                <div id="mapid"></div>
                                <button class="btn btn-sm btn-responsive btn-success create-button" type="submit" value="Save" style="margin-top: 20px; float: right; border: 1px solid var(--light-gray);">Save</button>
                            </div>
                        </fieldset>
                    </form>
                </div>
            </div>
        </div>
        <div class="col-sm-8">
            <div id="spinner" hidden="hidden">
                <i class="fa fa-spinner fa-pulse fa-3x fa-fw"></i>
                <span class="sr-only">Loading...</span>
            </div>
            <div id="sensorchart" class="card" style="width: 100%;"></div>
            <div class="sensors-asset card">
                <h3>All sensors for {{ asset.name }}</h3>
                <table class="table table-striped table-responsive paginate nav-on-click" title="View data">
                    <thead>
                        <tr>
                            <th>Name</th>
                            <th class="text-right">Unit</th>
                            <th class="text-right">Resolution</th>
                            <th class="text-right no-sort">Entity address</th>
                            <th class="hidden">URL</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for sensor in asset.sensors: %}
                        <tr>
                            <td>
                                {{ sensor.name }}
                            </td>
                            <td class="text-right">
                                {{ sensor.unit }}
                            </td>
                            <td class="text-right">
                                {{ sensor.event_resolution | naturalized_timedelta }}
                            </td>
                            <td class="text-right">
                                {{ sensor.entity_address }}
                            </td>
                            <td class="hidden">
                                /sensors/{{ sensor.id }}
                            </td>
                        </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
        <div class="col-sm-2">
            <div class="replay-container">
                <div id="replay" title="Press 'p' to play/pause/resume or 's' to stop." class="stopped"></div>
                <div id="replay-time"></div>
            </div>
        </div>
    </div>


</div>

<script src="https://cdnjs.cloudflare.com/ajax/libs/jstimezonedetect/1.0.7/jstz.js"></script>
<script src="https://cdn.jsdelivr.net/npm/litepicker/dist/litepicker.js"></script>
<script src="https://cdn.jsdelivr.net/npm/litepicker/dist/plugins/ranges.js"></script>
<script src="https://cdn.jsdelivr.net/npm/litepicker/dist/plugins/keyboardnav.js"></script>

{% block leftsidepanel %} {{ super() }} {% endblock %}
{% block sensorChartSetup %} {{ super() }} {% endblock %}

<!-- Initialise the map -->
<script src="https://cdn.jsdelivr.net/npm/leaflet@1.7.1/dist/leaflet-src.min.js"></script>
<script src="{{ url_for('flexmeasures_ui.static', filename='js/map-init.js') }}"></script>

<script type="text/javascript">

    // create map
    var assetMap = L
        .map('mapid', { center: [{{ asset.latitude | replace("None", 10) }}, {{ asset.longitude | replace("None", 10) }}], zoom: 10})
        .on('popupopen', function () {
            $(function () {
                $('[data-toggle="tooltip"]').tooltip();
            });
        });
    addTileLayer(assetMap, '{{ mapboxAccessToken }}');

    // create marker
    var asset_icon = new L.DivIcon({
        className: 'map-icon',
        html: '<i class="icon-empty-marker center-icon supersize"></i><i class="overlay center-icon {{ asset.generic_asset_type.name | default("info") | asset_icon }}"></i>',
        iconSize: [100, 100], // size of the icon
        iconAnchor: [50, 50], // point of the icon which will correspond to marker's location
        popupAnchor: [0, -50] // point from which the popup should open relative to the iconAnchor
    });
    var marker = L
        .marker(
            [{{ asset.latitude | replace("None", 10)}}, {{ asset.longitude | replace("None", 10) }}],
    { icon: asset_icon }
        ).addTo(assetMap);

    assetMap.on('click', function (e) {
        $("#latitude").val(e.latlng.lat.toFixed(4));
        $("#longitude").val(e.latlng.lng.toFixed(4));
        marker.setLatLng(e.latlng);
    });
</script>

{% endblock %}